class AircraftManager {

	name = null;
	towns_used = null;
	route_1 = null;
	route_2 = null;
	distance_of_route = {};
	vehicle_to_depot = {};
	delay_build_airport_route = 1000;
	passenger_cargo_id = -1;
	tourist_cargo_id = -1;
	_group_id = null;
	_best_engine = null;
	_replacing_engine_small = null;
	_replacing_engine_big = null;
	_replacing_engine_heli = null;
	autoreplace_in_process = false;
	
	constructor() {
		this.towns_used = AIList();
		this.route_1 = AIList();
		this.route_2 = AIList();
		this._replacing_engine_small = _replacing_engine_small;
		this._replacing_engine_big = _replacing_engine_big;
		this._replacing_engine_heli = _replacing_engine_heli;
		this.autoreplace_in_process = autoreplace_in_process;

		local list = AICargoList();
		for (local i = list.Begin(); list.HasNext(); i = list.Next()) {
			if (AICargo.HasCargoClass(i, AICargo.CC_PASSENGERS) && AICargo.GetCargoLabel(i) == "PASS" ) {
				this.passenger_cargo_id = i;
				//break;
			}
			if (AICargo.HasCargoClass(i, AICargo.CC_PASSENGERS) && AICargo.GetCargoLabel(i) == "TOUR" ) {
				this.tourist_cargo_id = i;
				//break;
			}
		}
	}
	
	function Save() {
		local table = {};
		
		if (_replacing_engine_small != null ) table.rawset("replacing_engine_small", _replacing_engine_small);
		
		if (_replacing_engine_heli != null ) table.rawset("replacing_engine_heli", _replacing_engine_heli);
		
		if (_replacing_engine_big != null ) table.rawset("replacing_engine_big", _replacing_engine_big);
		
		if (distance_of_route != null ) table.rawset("distance_of_route", distance_of_route);
		
		if (vehicle_to_depot != null ) table.rawset("vehicle_to_depot", vehicle_to_depot);
		
		
		/*if (route_1 != null ) table.rawset("route_1", route_1);
		
		if (route_2 != null ) table.rawset("route_2", route_2);
		*/
		return table;
	}
	
	function Load(version, data) {
		
		if (data.rawin("replacing_engine_small"))
			_replacing_engine_small = data.rawget("replacing_engine_small");
			
		if (data.rawin("replacing_engine_heli"))
			_replacing_engine_heli = data.rawget("replacing_engine_heli");
		
		if (data.rawin("replacing_engine_big"))
			_replacing_engine_big = data.rawget("replacing_engine_big");	
		
		if (data.rawin("distance_of_route")) distance_of_route = data.rawget("distance_of_route");
		
		if (data.rawin("vehicle_to_depot")) vehicle_to_depot = data.rawget("vehicle_to_depot");
		
				
		/*if (data.rawin("route_1")) route_1 = data.rawget("route_1");
		
		if (data.rawin("route_2")) route_2 = data.rawget("route_2");
		*/
		
		if ( this._CheckBestEngine(1) != 0 ) {
		AILog.Info("Debug: best se: "+AIEngine.GetName(this._CheckBestEngine(1)));	
		if ( this._replacing_engine_small != null ) {
			AILog.Info("replacing se "+AIEngine.GetName(_replacing_engine_small));
		}}
		
		if ( this._CheckBestEngine(0) != 0 ) {
		AILog.Info("Debug: best be: "+AIEngine.GetName(this._CheckBestEngine(0)));	
		if ( this._replacing_engine_big != null ) {
			AILog.Info("replacing be "+AIEngine.GetName(_replacing_engine_big));
		}}
		
		if ( this._CheckBestEngine(2) != 0 ) {
			AILog.Info("Debug: best he: "+AIEngine.GetName(this._CheckBestEngine(2)));	
		if ( this._replacing_engine_heli != null ) {
			AILog.Info("replacing he "+AIEngine.GetName(_replacing_engine_heli));
		}}
	}	
};

/**
 * Rename Vehicles Group //TODO
 */
function AircraftManager::_RenameGroup(group_id, station_1, station_2) {
	
	local new_name = "_"+AIStation.GetName(station_1)+"-"+AIStation.GetName(station_2);
	new_name = new_name.slice(0, min(new_name.len(), 30));
	AIGroup.SetName(this._group_id, new_name);
}


/**
 * Delete empty Vehicles Group 
 */
function AircraftManager::_DeleteGroups() {
	
	local groups = AIGroupList();
	foreach (g, _ in groups) {
    
		local list = AIVehicleList_Group(g);
		if (list.Count() == 0) AIGroup.DeleteGroup(g);
			
	}
	
}


/**
 * Start Autoreplace vehicles in given group
 */
function AircraftManager::_RunAutoreplace(group_id, type, engine_id_new) {
	
	local engine, small_group;
		
		
	
	// replace small group
	small_group = AIVehicleList();
	small_group.Valuate(AIVehicle.GetVehicleType);
    small_group.KeepValue(AIVehicle.VT_AIR);
	small_group.Valuate(AIVehicle.GetEngineType);
	
	foreach (v, engine in small_group) {
		
	engine = AIVehicle.GetEngineType(v);
	
	
		if ( AIEngine.GetPlaneType(engine) == AIAirport.PT_BIG_PLANE&& type == 0  && engine != engine_id_new  ) {
			
		AIGroup.StopAutoReplace(group_id, engine);
		AIGroup.SetAutoReplace(group_id, engine, engine_id_new);
		AIVehicle.SendVehicleToDepotForServicing(v);
		
		this._replacing_engine_big = engine_id_new;
AILog.Info("replacing"+AIEngine.GetName(engine)+" / "+AIEngine.GetName(engine_id_new));
			
		} else if (AIEngine.GetPlaneType(engine) == AIAirport.PT_SMALL_PLANE && type == 1 && engine != engine_id_new  ) {
			
		AIGroup.StopAutoReplace(group_id, engine);
		AIGroup.SetAutoReplace(group_id, engine, engine_id_new);
		AIVehicle.SendVehicleToDepotForServicing(v);
AILog.Info("replacing"+AIEngine.GetName(engine)+" / "+AIEngine.GetName(engine_id_new));
		this._replacing_engine_small = engine_id_new;
			
		} else if ( AIEngine.GetPlaneType(engine) == AIAirport.PT_HELICOPTER && type == 2 && engine != engine_id_new  ) {

		AIGroup.StopAutoReplace(group_id, engine);
		AIGroup.SetAutoReplace(group_id, engine, engine_id_new);
		AIVehicle.SendVehicleToDepotForServicing(v);
		AILog.Info("replacing"+AIEngine.GetName(engine)+" / "+AIEngine.GetName(engine_id_new));
		this._replacing_engine_heli = engine_id_new;
		}
	}
		

	
	
	
}


/**
 * Check engine IDs and run autoreplace if newer engine available 
 */
function AircraftManager::_CheckAutoreplace() {
	
		
	local new_enj_small = this._CheckBestEngine(1);
	local new_enj_big = this._CheckBestEngine(0);
	local new_enj_heli = this._CheckBestEngine(2);
	
		
	this._RunAutoreplace(AIGroup.GROUP_ALL, 1, new_enj_small );
	
			
	this._RunAutoreplace(AIGroup.GROUP_ALL, 2, new_enj_heli );
	
			
	this._RunAutoreplace(AIGroup.GROUP_ALL, 0, new_enj_big );
	
		
}

/**
 * Check for the best available engine 
 */
function AircraftManager::_CheckBestEngine (type) {
	
	local list = AIEngineList(AIVehicle.VT_AIR);
	list.Valuate(AIEngine.IsBuildable);
	list.KeepValue(true.tointeger());
	list.Valuate(AIEngine.CanRefitCargo, this.passenger_cargo_id);
	list.KeepValue(true.tointeger());
	
	list.Valuate(AIEngine.GetCapacity);
	list.KeepAboveValue(6); //eyecandy
	
	list.Valuate(AIEngine.GetPlaneType);
	if ( type == 1 ) {
		list.RemoveValue(AIAirport.PT_BIG_PLANE);
	} else if ( type == 2 ) {
		list.RemoveValue(AIAirport.PT_BIG_PLANE);
		list.RemoveValue(AIAirport.PT_SMALL_PLANE);
	} else if ( type != 0 ) {
		AILog.Error("Wrong plan type param");
		return 0;
	}	
	
	list.Valuate(this._GetEnginePower, list);
	list.Sort(AIAbstractList.SORT_BY_VALUE, AIAbstractList.SORT_DESCENDING);
	
	local new_best_engine = null;
	if (list.Count() != 0) {
		
		new_best_engine = list.Begin();
		//AILog.Info("best engine is "+AIEngine.GetName(new_best_engine));
		return new_best_engine;
		
	} else return 0;
	
}

/**
 * Check for the best available engine params (used for sorting)
 * formula for NBR: 
 * ( capacity * speed ) - ( running cost/1000 )
 * 
 * formula fr BR:
 * ( capacity * speed ) + ( relability * 100 )
 * + keep out relability values lower than 65 //TODO
 */
function AircraftManager::_GetEnginePower (engine_id, n) {
	
	local n = null;
	//calculate accordingly to breakdown settings
	if ( AIGameSettings.GetValue("vehicle_breakdowns") == 0 ) {

		n = ( AIEngine.GetCapacity(engine_id).tointeger() * AIEngine.GetMaxSpeed(engine_id).tointeger() ) - ( AIEngine.GetRunningCost(engine_id).tointeger() / 1000 );
		
		//AILog.Info("Id: "+engine_id+" name: "+AIEngine.GetName(engine_id)+" capacity: "+AIEngine.GetCapacity(engine_id).tointeger()+" speed: "+AIEngine.GetMaxSpeed(engine_id).tointeger()+" cost: "+AIEngine.GetRunningCost(engine_id).tointeger() );
		
		
	} else {
		
		n =	( AIEngine.GetCapacity(engine_id).tointeger() * AIEngine.GetMaxSpeed(engine_id).tointeger() ) + ( AIEngine.GetRelaibility(engine_id).tointeger() * 100 );
				
	}
	
	
	//AILog.Info("epower is: "+n);
	return n;
}

/**
 * Build an airport route. 
 */
function AircraftManager::BuildAirportRoute() {
	
	//list best airport types, try each
	
	local airport_types = [AIAirport.AT_INTERCON, AIAirport.AT_INTERNATIONAL, AIAirport.AT_METROPOLITAN, AIAirport.AT_LARGE, AIAirport.AT_COMMUTER, AIAirport.AT_SMALL, AIAirport.AT_HELISTATION, AIAirport.AT_HELIDEPOT];
	local tile_1, tile_2, at, distance;
	
	AILog.Warning("NETWORK: Trying to build new Air route");
	Util.GetMaxLoan();
	
	foreach (airport_type in airport_types) {
		
		
		//check only airports we can build now
		if ( !AIAirport.IsValidAirportType(airport_type)) continue;	
		//AILog.Info("c "+airport_type);
			
		tile_1 = this.FindSuitableAirportSpot(airport_type, 0);
		tile_2 = this.FindSuitableAirportSpot(airport_type, tile_1);
		distance = AIMap.DistanceManhattan(tile_1, tile_2);
		
		if (tile_1 > 0 && tile_2 > 0) {
			
			
	
			if (distance < 100 ) {
				this.towns_used.RemoveValue(tile_1);
				this.towns_used.RemoveValue(tile_2);
				AILog.Error("NETWORK: coudn't build the route - wrong distance range (" + distance + ")");
				continue;

			} else {
				//we ready to build
				at = airport_type;
				break;
				}
	
			}
			
		}
	if (tile_1 < 0 || tile_2 < 0 || distance < 100 ) return -2;

	

	/* Build the airports for real */
	if (!AIAirport.BuildAirport(tile_1, at, AIStation.STATION_NEW)) {
		AILog.Error("NETWORK: Although the testing told us we could build 2 airports, it still failed on the first airport at tile " + tile_1 + ".");
		this.towns_used.RemoveValue(tile_1);
		this.towns_used.RemoveValue(tile_2);
		return -3;
	}
	if (!AIAirport.BuildAirport(tile_2, at, AIStation.STATION_NEW)) {
		AILog.Error("NETWORK: Although the testing told us we could build 2 airports, it still failed on the second airport at tile " + tile_2 + ".");
		AIAirport.RemoveAirport(tile_1);
		this.towns_used.RemoveValue(tile_1);
		this.towns_used.RemoveValue(tile_2);
		return -4;
	}

	local ret = this.BuildAircraft(tile_1, tile_2, at);
	if (ret < 0) {
		AIAirport.RemoveAirport(tile_1);
		AIAirport.RemoveAirport(tile_2);
		this.towns_used.RemoveValue(tile_1);
		this.towns_used.RemoveValue(tile_2);
		return ret;
	}

	AILog.Info("NETWORK: Done building air route");
	return ret;
}

/** 
 * determine if we have enough funds to start new network
 */
function AircraftManager::CanBuildNetwork() {

	local engine_list = AIEngineList(AIVehicle.VT_AIR);
	
	Util.GetMaxLoan();
	local balance = AICompany.GetBankBalance(AICompany.COMPANY_SELF) - 30000;
	Util.PayDownLoan();
	
	if (AIEngine.GetPrice(this._CheckBestEngine(1).tointeger()) > ( balance/2 )) return false;
	else return true;
	}

/**
 * Build an aircraft with orders from tile_1 to tile_2.
 *  The best available aircraft of that time will be bought.
 */
function AircraftManager::BuildAircraft(tile_1, tile_2, et) {
	
	/* Build an aircraft */
	local hangar = AIAirport.GetHangarOfAirport(tile_1);
	local hangar_2 = AIAirport.GetHangarOfAirport(tile_2);
	//AILog.Warning("hangar"+hangar+" / "+tile_1);
	//if newgrfs use range, calculate it
	//local route_range = AIOrder.GetOrderDistance(AIVehicle.VT_AIR, tile_1, tile_2);
	
	//local route_range = 800;
	//local engine_range = AIEngine.GetMaximumOrderDistance

	local engine = null;
	
	Util.GetMaxLoan();
	//engine_list.Valuate(AIEngine.GetMaximumOrderDistance);
	//engine_list.RemoveBetweenValue(1, route_range);


	if ( et == AIAirport.AT_COMMUTER || et == AIAirport.AT_SMALL ) engine = this._CheckBestEngine (1);
	else if ( et == AIAirport.AT_HELISTATION || et == AIAirport.AT_HELIDEPOT ) engine = this._CheckBestEngine (2);
	else engine = this._CheckBestEngine (0);
	
	if (!AIEngine.IsValidEngine(engine)) {
		AILog.Warning("Couldn't find a suitable engine");
		return -5;
	}
	
	local vehicle = AIVehicle.BuildVehicle(hangar, engine);
		
	if (!AIVehicle.IsValidVehicle(vehicle) && !AIVehicle.RefitVehicle(vehicle, this.passenger_cargo_id) ) {
		AILog.Error("Couldn't build the aircraft "+AIEngine.GetName(engine)+"  hangar: "+hangar);
		return -6;
	}
	
	/* Send him on his way */
	AIOrder.AppendOrder(vehicle, tile_1, AIOrder.AIOF_FULL_LOAD_ANY);
	//AIOrder.AppendOrder(vehicle, hangar, AIOrder.AIOF_SERVICE_IF_NEEDED);
	//OF_FULL_LOAD_ANY) OF_NONE;
	AIOrder.AppendOrder(vehicle, tile_2, AIOrder.AIOF_FULL_LOAD_ANY);
	//AIOrder.AppendOrder(vehicle, hangar_2, AIOrder.AIOF_SERVICE_ALWAYS);
	
	AIVehicle.StartStopVehicle(vehicle);
		
	//add to autoreplace db
	if ( et == AIAirport.AT_COMMUTER || et == AIAirport.AT_SMALL ) this._replacing_engine_small = engine;
	else if ( et == AIAirport.AT_HELISTATION || et == AIAirport.AT_HELIDEPOT ) this._replacing_engine_heli = engine;
	else this._replacing_engine_big = engine;

	this._group_id = AIGroup.CreateGroup(AIVehicle.VT_AIR);
	this._RenameGroup(this._group_id, AIStation.GetStationID(tile_1), AIStation.GetStationID(tile_2));
	AIGroup.MoveVehicle(this._group_id, vehicle);
	
	
	//clone aircraft
	
     local vehicle_2 = AIVehicle.CloneVehicle(AIAirport.GetHangarOfAirport(tile_2), vehicle, true);
	if (!AIVehicle.IsValidVehicle(vehicle_2)) {
		AILog.Warning("CLONE: Cloning plane failed: " + AIError.GetLastErrorString());
		
	} else {
		
			
			/* Start with going to the second airport. */
		AIOrder.SkipToOrder(vehicle_2, 1);
		AIVehicle.StartStopVehicle(vehicle_2);
	}
	
	AILog.Info("NETWORK: Done building 2 vehicles for cargo "+AICargo.GetCargoLabel(this.passenger_cargo_id));
	return 0;
}

function AircraftManager::_GetAllowedNoise(airport_type) {
	
	if (AIGameSettings.GetValue("economy.station_noise_level") == 0) {
	return 1;  	
	} else {
		
	switch (airport_type) {
		case AIAirport.AT_SMALL:         return 3;
		case AIAirport.AT_LARGE:         return 5;
		case AIAirport.AT_METROPOLITAN:  return 8;
		case AIAirport.AT_INTERNATIONAL: return 17;
		case AIAirport.AT_COMMUTER:      return 4;
		case AIAirport.AT_INTERCON:      return 28;
		case AIAirport.AT_HELISTATION:	 return 3;
		case AIAirport.AT_HELIDEPOT: 	return 2;
		default: return 3;
	}
}
}



/**
 * Find a suitable spot for an airport
 */
function AircraftManager::FindSuitableAirportSpot(airport_type, center_tile) {
	local airport_x, airport_y, airport_rad;
	local noise = this._GetAllowedNoise(airport_type) - 1;
	
	
	airport_x = AIAirport.GetAirportWidth(airport_type);
	airport_y = AIAirport.GetAirportHeight(airport_type);
	airport_rad = AIAirport.GetAirportCoverageRadius(airport_type);
	
	local population_size = 300;
	
	local town_list = AITownList();
	/* Remove all the towns we already used */
	town_list.RemoveList(this.towns_used);
	town_list.Valuate(AITown.GetAllowedNoise);
	town_list.KeepAboveValue(noise);
	town_list.Valuate(AITown.GetPopulation);
	town_list.KeepAboveValue(population_size);
	
	town_list.Sort(AIAbstractList.SORT_BY_VALUE, AIAbstractList.SORT_DESCENDING);

	//town_list.KeepTop(20);
	//town_list.Valuate(AIBase.RandItem);

	/* Now find 2 suitable towns */
	for (local town = town_list.Begin(); town_list.HasNext(); town = town_list.Next()) {

		AIController.Sleep(1);

		local tile = AITown.GetLocation(town);
		AILog.Info("checking " + AITown.GetName(town)+" noise "+noise);

		/* Create a 30x30 grid around the core of the town and see if we can find a spot for a small airport */
		local list = AITileList();
		/* XXX -- We assume we are more than 15 tiles away from the border! */
		list.AddRectangle(tile - AIMap.GetTileIndex(15, 15), tile + AIMap.GetTileIndex(15, 15));
		list.Valuate(AITile.IsBuildableRectangle, airport_x, airport_y);
		list.KeepValue(1);
		if (center_tile != 0) {
			/* If we have a tile defined, we don't want to be within 25 tiles of this tile */
			list.Valuate(AITile.GetDistanceSquareToTile, center_tile);
			list.KeepAboveValue(3625);
		}
		/* Sort on acceptance, remove places that don't have acceptance */
		list.Valuate(AITile.GetCargoAcceptance, this.passenger_cargo_id, airport_x, airport_y, airport_rad);
		list.RemoveBelowValue(10);

		/* Couldn't find a suitable place for this town, skip to the next */
		if (list.Count() == 0) continue;
		/* Walk all the tiles and see if we can build the airport at all */
		{
			local test = AITestMode();
			local good_tile = 0;

			for (tile = list.Begin(); list.HasNext(); tile = list.Next()) {
				AIController.Sleep(1);
				if (!AIAirport.BuildAirport(tile, airport_type, AIStation.STATION_NEW)) continue;
				good_tile = tile;
				break;
			}

			/* Did we found a place to build the airport on? */
			if (good_tile == 0) continue;
		}

		AILog.Info("Found a good spot for an airport in town " + AITown.GetName(town) + "("+town+") at tile " + tile+" using AT "+airport_type);

		/* Make the town as used, so we don't use it again */
		this.towns_used.AddItem(town, tile);

		return tile;
	}

	AILog.Info("Couldn't find a suitable town to build an airport type "+airport_type);
	return -1;
}


/**
 * Check if routes need new vehicles and it if needed
 */
function AircraftManager::_RunAddNewVehicles() {
	
	local max_veh_per_type = 16;
	local cargo = this.passenger_cargo_id;
	
	//todo - selection by airport type
	
	local list = AIStationList(AIStation.STATION_AIRPORT);
	list.Valuate(AIStation.GetCargoWaiting, cargo);
	list.KeepAboveValue(20); //first check if we have any cargo
	list.Valuate(AIStation.GetCargoRating, cargo);
	list.KeepBelowValue(68);
	list.Sort(AIAbstractList.SORT_BY_VALUE, AIAbstractList.SORT_DESCENDING);
	
	AILog.Warning("--- Monitoring Air Routes for "+AICargo.GetCargoLabel(cargo) );

	for (local i = list.Begin(); list.HasNext(); i = list.Next()) {
		
				

		local list2 = AIVehicleList_Station(i);
		
		// if any empty airport for no reason
		if (list2.Count() == 0) {
			this._SellAirports(i);
			continue;
		};
		
		//already too much of aircaft? proceed is we can add another one
		if (list2.Count() < max_veh_per_type) {			
		
		local v = list2.Begin();


		AILog.Info("MONITOR: "+AIStation.GetName(i)+" >> | Rating: "+AIStation.GetCargoRating(i, cargo)+" | Waiting: "+AIStation.GetCargoWaiting(i, cargo)+" | Vehicles: "+list2.Count());
		

		//determine if we have low passenger value due to poor station rating
		if ( AIStation.GetCargoRating(i, cargo) < 38 && list2.Count() > 0 && list2.Count() < 4) {
			
			AILog.Info("EXEC: " + AIStation.GetName(i) + " has low rating due to lack of vehicles, adding new vehicle for the route.");
			
			//clone aircraft
			this._CloneAircraft(i, v);
		
		} else if ( AIStation.GetCargoRating(i, cargo) < 55 && list2.Count() > 0 && list2.Count() < 6 && AIStation.GetCargoWaiting(i, cargo) > 50 ) {
			
			AILog.Info("EXEC: " + AIStation.GetName(i) + " has decent rating and some waiting cargo, adding new vehicle for the route.");
			
			//clone aircraft
			this._CloneAircraft(i, v);
			
		} else if ( AIStation.GetCargoWaiting(i, cargo) > 200 ) {
			
			AILog.Info("EXEC: " + AIStation.GetName(i) + " has too many cargo, adding a new vehicle for the route.");
			
			//clone aircraft
			this._CloneAircraft(i, v);
			
		}


	
}
	}
	
}

function AircraftManager::_CloneAircraft(i, v) {

	local station_1 = AIStation.GetStationID(AIOrder.GetOrderDestination(v, 0));
	local station_2 = AIStation.GetStationID(AIOrder.GetOrderDestination(v, 1));
	local plane_type = AIAirport.GetAirportType(AIStation.GetLocation(i));
	local engine, vehicle_2, i_station, st, d_station, vs;
	local s_station = -1;
		
	//check if we clone too soon
	if ( AIVehicle.GetAge(v) < 30 ) {
			AILog.Info("CLONE: Can't clone - route already have new vehicles"); return true;
	}
	
	//check if one of the other route station delayed transportation
	
	if ( (AIStation.GetCargoWaiting(station_1, this.passenger_cargo_id) < 10 && AIStation.GetCargoRating(station_1, this.passenger_cargo_id) > 60) || (AIStation.GetCargoWaiting(station_2, this.passenger_cargo_id) < 10 && AIStation.GetCargoRating(station_2, this.passenger_cargo_id) > 60) ) {
		
			AILog.Info("CLONE: Can't clone - one of the stations delay transportation.Trying to add vehicles to alternate route"); 
			
			
			//try to clone for 2d route, determine the target station
			
			if ( (AIStation.GetCargoWaiting(station_1, this.passenger_cargo_id) < 10 && AIStation.GetCargoRating(station_1, this.passenger_cargo_id) > 60) )			 i_station = station_2;
			else i_station = station_1; 
			
			st = AIVehicleList_Station(i_station);
			for (local vs = st.Begin(); st.HasNext(); vs = st.Next()) {
			
			if ( st.Count() < 16 ) {
			
			//check vehicle orders to find 3d station assigned to 2d route
			if ( AIStation.GetStationID(AIOrder.GetOrderDestination(vs, 0)) != i_station ) {
				s_station = AIStation.GetStationID(AIOrder.GetOrderDestination(vs, 0));
				v = vs;
				//AILog.Info("CLONE 0 "+i_station+" / "+s_station+" / "+AIStation.GetCargoWaiting(s_station, this.passenger_cargo_id)+" vs "+v);
				
			} else if ( AIStation.GetStationID(AIOrder.GetOrderDestination(vs, 1)) != i_station ) {
				s_station = AIStation.GetStationID(AIOrder.GetOrderDestination(vs, 1));
				v = vs;
				//AILog.Info("CLONE 1 "+i_station+" / "+s_station+" / "+AIStation.GetCargoWaiting(s_station, this.passenger_cargo_id)+" vs "+v);
				
			}
			
			if (s_station > 0 && AIStation.GetCargoWaiting(s_station, this.passenger_cargo_id) > 150 ) {
				//AILog.Info("CLONE 6 "+i_station+" / "+s_station+" / "+AIStation.GetCargoWaiting(s_station, this.passenger_cargo_id));
				break;
			} else { s_station = -1;}
			
			}
			}
		
			if ( s_station < 0 ) {
				
			AILog.Info("CLONE: Can't find 2d route.Trying to add alternate route");
			//or run route manager
			this._RunAddAlternateRoute();
			return true;
				
			} else {
			//v = vs;
			i = s_station;
			//AILog.Info("CLONE"+AIStation.GetLocation(i)+" / "+v);	
			}
	}
	
				
		
	Util.GetMaxLoan();
    vehicle_2 = AIVehicle.CloneVehicle(AIAirport.GetHangarOfAirport(AIStation.GetLocation(i)), v, true);
     
	if (!AIVehicle.IsValidVehicle(vehicle_2) && AIEngine.IsBuildable(vehicle_2)) {
		AILog.Warning("CLONE: Cloning plane failed: " + AIStation.GetLocation(i) +" error: "+AIError.GetLastErrorString());
		
		
		return false;
		
	} else if (!AIVehicle.IsValidVehicle(vehicle_2) && !AIEngine.IsBuildable(vehicle_2)) {
		
				//try to build new model
		AILog.Info("CLONE: Model "+vehicle_2+" is not available, trying to build new model");
		
	if ( plane_type == AIAirport.AT_COMMUTER || plane_type == AIAirport.AT_SMALL ) engine = this._CheckBestEngine (1);
	else if ( plane_type == AIAirport.AT_HELISTATION || plane_type == AIAirport.AT_HELIDEPOT ) engine = this._CheckBestEngine (2);
	else engine = this._CheckBestEngine (0);
		
		vehicle_2 = AIVehicle.BuildVehicle(AIAirport.GetHangarOfAirport(AIStation.GetLocation(i)), engine);
		
		if (AIVehicle.IsValidVehicle(vehicle_2)) {
			 AIOrder.ShareOrders(vehicle_2, v);
			 
			 //correct groups
			 this._group_id = AIGroup.CreateGroup(AIVehicle.VT_AIR);
			 AIGroup.SetName(this._group_id, "_temp");
	
			 local shared = AIVehicleList_SharedOrders(v);
			 foreach (veh, _ in shared) {
				 AIGroup.MoveVehicle(this._group_id, veh);
				 }
			 
			 this._DeleteGroups();
			 this._RenameGroup(this._group_id, station_1, station_2);
			 
			 
			 
			 
			} else {
			AILog.Warning("CLONE: Building new plane failed: " + AIStation.GetLocation(i) +" error: "+AIError.GetLastErrorString());	
			return false;
		}
		
		
	} 
					
		//determine home airport and switch order
		
		if ( i == station_1 || i == AIStation.GetStationID(AIOrder.GetOrderDestination(vehicle_2, 0))) AIOrder.SkipToOrder(vehicle_2, 0);
		else AIOrder.SkipToOrder(vehicle_2, 1);
		
		AIVehicle.StartStopVehicle(vehicle_2);
		AILog.Warning("CLONE: Cloning done!");
		return true;
	
	
}

/**
 * check vehicles profit for the last 2 years and sell uplrofitable ones
 */
function AircraftManager::_AirProfitability() {

    local list = AIVehicleList();
	list.Valuate(AIVehicle.GetAge);
	/* Give the plane at least 2 years to make a difference */
	list.KeepAboveValue(365 * 2);
	list.Valuate(AIVehicle.GetProfitLastYear);
	
	AILog.Warning("--- Monitoring Air Profit");

	for (local i = list.Begin(); list.HasNext(); i = list.Next()) {
		local profit = list.GetValue(i);
		/* Profit last year and this year bad? Let's sell the vehicle */
		if ( (profit < 100 && AIVehicle.GetProfitThisYear(i) < 100 ) ) {
			/* Send the vehicle to depot if we didn't do so yet */
			if (!vehicle_to_depot.rawin(i) || vehicle_to_depot.rawget(i) != true) {
				
		
				AILog.Info("LOSS: Sending " + AIVehicle.GetName(i) + " to depot as profit is: " + profit + " / " + AIVehicle.GetProfitThisYear(i) + " and age is: "+AIVehicle.GetAge(i)+" days" );
				
				AIVehicle.SendVehicleToDepot(i);
				vehicle_to_depot.rawset(i, true);
			}
		}

	}

		//sell all stopped vehicles and kill airports
		
	local planeList = AIVehicleList();
	planeList.Valuate(AIVehicle.GetVehicleType);
    planeList.KeepValue(AIVehicle.VT_AIR);
    planeList.Valuate(AIVehicle.GetState);
    planeList.KeepValue(AIVehicle.VS_IN_DEPOT);
    planeList.Valuate(AIVehicle.GetAge);
	planeList.KeepAboveValue(3);
	
    
    for (local plane = planeList.Begin(); planeList.HasNext(); plane = planeList.Next()) {
		
		local pname = AIVehicle.GetName(plane);
		
        if (AIVehicle.SellVehicle(plane)) {
            AILog.Info("LOSS: Selling " + pname);
            
				//sell empty airports if any
				this._SellAirports(null);
				
        }
    }    
	
		
}


/**
 * manager daemon
 */
function AircraftManager::ManageAirRoutes() {
	
	//run profitability manager
	this._AirProfitability();
	
	this._CheckAutoreplace();
	
	//add new vehicles to the route if needed
	this._RunAddNewVehicles();
	
	//upgrade airports :: TODO
	//this._RunAddNewVehicles();
	


}

function AircraftManager::_RunAddAlternateRoute() {

	local max_veh_per_type = 16;
	local cargo = this.passenger_cargo_id;
	local kl = -1;
	local kl2 = -1;
	local plane_type = "";
	local ord_station_1, ord_station_2;
			
	local list = AIStationList(AIStation.STATION_AIRPORT);
	list.Valuate(AIStation.GetCargoWaiting, cargo);
	list.KeepAboveValue(100); //first check if we have alot of cargo
	list.Sort(AIAbstractList.SORT_BY_VALUE, AIAbstractList.SORT_DESCENDING);
	
	AILog.Warning("--- Researching on Alternate Air Routes for "+AICargo.GetCargoLabel(cargo) );

	for (local v1 = list.Begin(); list.HasNext(); v1 = list.Next()) {
		
		local list2 = AIVehicleList_Station(v1);
		local vehicle = list2.Begin();
		
		ord_station_1 = AIStation.GetStationID(AIOrder.GetOrderDestination(vehicle, 0));
		
		ord_station_2 = AIStation.GetStationID(AIOrder.GetOrderDestination(vehicle, 1));
	
		plane_type = AIAirport.GetAirportType(AIStation.GetLocation(v1));		
		
		//test if we already created such route here
		local shared = AIVehicleList_SharedOrders(vehicle);
		
				
		if (list2.Count() < max_veh_per_type && shared.Count() == list2.Count() ) {
				
			
				if ( kl < 0 ) {
					
					kl = v1;
					AILog.Info("MONITOR: Station 1: "+AIStation.GetCargoWaiting(kl, this.passenger_cargo_id)+" >> "+AIStation.GetName(kl));
					continue;
					
				} else if ( kl2 < 0 ) {
					
					kl2 = v1;
					AILog.Info("MONITOR: Station 2: "+AIStation.GetCargoWaiting(kl2, this.passenger_cargo_id)+" >> "+AIStation.GetName(kl2)+" / distance "+AIMap.DistanceManhattan(AIStation.GetLocation(kl), AIStation.GetLocation(kl2)));
					
						if ( kl2 > 0 && AIMap.DistanceManhattan(AIStation.GetLocation(kl), AIStation.GetLocation(kl2)) < 100 ) {
						AILog.Info("MONITOR: stations too close, discarding selection");
						kl2 = -1;
						continue;
						} else if ( kl2 > 0 && kl2 != ord_station_1 && kl2 != ord_station_2 ) {
							AILog.Info("MONITOR: got 2 stations, looking for route"+ord_station_1+" "+ord_station_2);
							break;
						} else {
								continue;
						}
					
				} else if ( kl2 > 0 && kl > 0 ) {
					AILog.Info("MONITOR: ! got 2 stations, looking for route");
					break;
				}
					
		} else if (shared.Count() == list2.Count() ) {
			AILog.Info("EXEC: Can't add new route - " + AIStation.GetName(v1) + " - reached maximum for vehicles per station");
			continue;
		}
		
	}
	
		
	if ( kl != -1 && kl2 != -1 && kl2 != ord_station_1 && kl2 != ord_station_2 ) {
	AILog.Info("EXEC: New Route for " + AIStation.GetName(kl) + " / "+AIStation.GetName(kl2)+" PT "+plane_type);
			
	//create aircraft
	this.BuildAircraft(AIStation.GetLocation(kl), AIStation.GetLocation(kl2), plane_type);
	} else if ( kl != -1 && kl2 != -1 ) {
		AILog.Info("MONITOR: Can't find anyting suitable for new route. Will try later.");
		}
}


function AircraftManager::_LookForAirport(airport) {
	
	local noise;
	local tile = AIAirport.GetHangarOfAirport(AIStation.GetLocation(airport));
	local airport_type = AIAirport.AT_LARGE;
	
	local airport_x = AIAirport.GetAirportWidth(airport_type);
	local airport_y = AIAirport.GetAirportHeight(airport_type);
	local airport_rad = AIAirport.GetAirportCoverageRadius(airport_type);
	
	

		AIController.Sleep(1);
				
		local list = AITileList();
		/* XXX -- We assume we are more than 15 tiles away from the border! */
		list.AddRectangle(tile - AIMap.GetTileIndex(15, 15), tile + AIMap.GetTileIndex(15, 15));
		list.Valuate(AITile.IsBuildableRectangle, airport_x, airport_y);
		list.KeepValue(1);
		//list.Valuate(AITile.GetDistanceSquareToTile, tile);
		//list.KeepBelowValue(20);
		
		
		
		/* Sort on acceptance, remove places that don't have acceptance */
		list.Valuate(AITile.GetCargoAcceptance, this.passenger_cargo_id, airport_x, airport_y, airport_rad);
		list.RemoveBelowValue(10);

		/* Couldn't find a suitable place for this town, skip to the next */
		if (list.Count() == 0) {
			AILog.Info("No good spots for " + AIStation.GetName(airport) +" using AT "+airport_type);
			
		} else {
		
		AIAirport.RemoveAirport(airport);
		
			local test = AITestMode();
			local good_tile = 0;

			for (tile = list.Begin(); list.HasNext(); tile = list.Next()) {
				AIController.Sleep(1);
				if (!AIAirport.BuildAirport(tile, airport_type, AIStation.STATION_NEW)) continue;
				good_tile = tile;
				break;
			}

			/* Did we found a place to build the airport on? */
			if (good_tile != 0) { 
		
		AIAirport.BuildAirport(tile, airport_type, airport);
		
		AILog.Info(AIStation.GetName(airport)+" Found a good spot at tile " + tile+" using AT "+airport_type);
	}

		

		return tile;
}	
	
}


/**
  * Sells the airports from route index i
  * 
  */
function AircraftManager::_SellAirports(i) {
	/* Remove the airports */
	
	if ( i == null ) {
	local list = AIStationList(AIStation.STATION_AIRPORT);
	
	for (local v = list.Begin(); list.HasNext(); v = list.Next()) {
		local list2 = AIVehicleList_Station(v);
		
		/* No vehicles going to this station, abort and sell */
		if (list2.Count() == 0) {
			local station_1 = AIAirport.GetHangarOfAirport(AIStation.GetLocation(v));
			AIAirport.RemoveAirport(station_1);
			this.towns_used.RemoveValue(station_1);
			AILog.Info("LOSS: Selling Empty airport "+station_1);
		};
	}
	} else {
			local station_1 = AIAirport.GetHangarOfAirport(AIStation.GetLocation(i));
			AIAirport.RemoveAirport(station_1);
			this.towns_used.RemoveValue(station_1);
			AILog.Info("LOSS: Selling Empty airport "+station_1);
	}

	//check groups and remove empty group
	//TODO

}


/**
 * events daemon
 */
function AircraftManager::HandleEvents() {
	while (AIEventController.IsEventWaiting()) {
		
		
		
		local e = AIEventController.GetNextEvent();
		switch (e.GetEventType()) {
			//vehicle crashed
			case AIEvent.AI_ET_VEHICLE_CRASHED: {
				local ec = AIEventVehicleCrashed.Convert(e);
				local v = ec.GetVehicleID();
				AILog.Warning("--- New Event");
				AILog.Warning("EVENT: We have a crashed vehicle (" + AIVehicle.GetName(v) + ")");
				
				this._CloneAircraft(AIStation.GetLocation(v), v);
				
							
				
			} break;

			case AIEvent.ET_ENGINE_AVAILABLE: {
				
				//new engine available
				local ec = AIEventEngineAvailable.Convert(e);
				local v = AIEngine.GetName(ec.GetEngineID());
				AILog.Warning("--- New Event");
				AILog.Info("EVENT: New available vehicle (" + v + "), maybe it's time for upgrade");
				
				//run autoreplace if better vehicle found
				this._CheckAutoreplace();
				
			} break;
			
			//accept vehicle for preview
			case AIEvent.AI_ET_ENGINE_PREVIEW: {
				
				AIEventEnginePreview.Convert(e).AcceptPreview();
				//run autoreplace if better vehicle found
				this._CheckAutoreplace();
				
				
			}break;

			default:
				break;
		}
	}
}
